/*
* SACD Decoder plugin
* Copyright (c) 2011-2015 Maxim V.Anisiutkin <maxim.anisiutkin@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with FFmpeg; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#pragma once

#include <windows.h>
#include <tchar.h>
#include <iasiodrv.h>

class asio_util_t {
public:
	static long getSampleSizeInBits(ASIOSampleType sampleType);
	static long getSamplePrecision(ASIOSampleType sampleType);
	static const char* getSampleTypeName(ASIOSampleType sampleType);
	static bool isMSB(ASIOSampleType sampleType);
	static bool isFP(ASIOSampleType sampleType);
	static const char* getFutureSelectorName(long selector);
	static const char* getMessageSelectorName(long selector);
	static const char* getIoFormatName(ASIOIoFormatType	format);
	static const char* getASIOError(ASIOError error);
};

