/*
* SACD Decoder plugin
* Copyright (c) 2011-2015 Maxim V.Anisiutkin <maxim.anisiutkin@gmail.com>
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU Lesser General Public
* License as published by the Free Software Foundation; either
* version 2.1 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public
* License along with FFmpeg; if not, write to the Free Software
* Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
*/

#pragma once

#include <windows.h>
#include <foobar2000.h>
#include "audio_device.h"

#define MAXDRVNAMELEN 128

class wasapi_device_t : public audio_device_t {
	CRITICAL_SECTION m_cs;
	GUID             m_guid;
	bool             m_trace;
	t_size                        m_channels;
	t_size                        m_samples;
	bool                          m_can_DSD;
	bool                          m_run_DSD;
	char                          m_name[MAXDRVNAMELEN];
public:
	static void enumerate(output_device_enum_callback& p_callback);
	wasapi_device_t();
	~wasapi_device_t();
	GUID get_GUID() {
		return m_guid;
	}
	t_size get_channels() {
		return m_channels;
	}
	t_size get_samples() {
		return m_samples;
	}
	bool get_can_DSD() {
		return m_can_DSD;
	}
	bool get_run_DSD() {
		return m_run_DSD;
	}
	const char* get_name() {
		return m_name;
	}
private:
};

